<?php

namespace App\Model;

use App\Scopes\TopDepartmentScope;
use Illuminate\Database\Eloquent\Model;

class ProductInventorySet extends Model
{
//    protected $fillable = ['userData','search'];
    protected $guarded = [];
    protected $table = "depart_set"; //指定表
    const CREATED_AT = 'crt_time';
    const UPDATED_AT = 'upd_time';
    protected $dateFormat = 'U';
    const type_one = 1;//校验锁定
    const type_two = 2;//不校验锁定

    public static $user = [];
    public static $search = [];
    public static $is_search = false;

    public function __construct(array $attributes = [])
    {
        if(! empty($attributes['userData'])) {
            self::$user = $attributes['userData'];
            self::$search = $attributes['search'];
            self::$is_search = true;
        }
        parent::__construct($attributes);
    }

    protected static function boot(){
        parent::boot();
        if(self::$is_search){
            static::addGlobalScope(new TopDepartmentScope(self::$user, self::$search));
        }
    }
}
