<?php

namespace App\Model;

use App\Scopes\DepartmentScope;
use Illuminate\Database\Eloquent\Model;

/**
 * 角色管理
 * Class Unit
 * @package App\Models
 */
class Role extends Model
{
    protected $guarded = [];
    protected $table = "role"; //指定表
    const CREATED_AT = 'crt_time';
    const UPDATED_AT = 'upd_time';
    protected $dateFormat = 'U';
    public static $user = [];
    public static $search = [];
    public static $is_search = false;
    const range_function = '';

    public function __construct(array $attributes = [])
    {
        if(! empty($attributes['userData'])) {
            self::$user = $attributes['userData'];
            self::$user['range_function'] = self::range_function;
            self::$search = $attributes['search'] ?? [];
            self::$is_search = true;
        }
        parent::__construct($attributes);
    }

    protected static function boot(){
        parent::boot();
        if(self::$is_search){
            static::addGlobalScope(new DepartmentScope(self::$user,self::$search));
        }
    }
}
